#ifndef NPSTAT_POLYPRIVATEUTILS_HH_
#define NPSTAT_POLYPRIVATEUTILS_HH_

//======================================================================
// polyPrivateUtils.hh
//
// This is an internal header which is subject to change without
// notice. Application code should never use classes or functions
// declared/defined in this header directly.
//
// Author: I. Volobouev
//
// October 2022
//======================================================================

#include "npstat/nm/AbsIntervalQuadrature1D.hh"
#include "npstat/nm/Matrix.hh"

namespace npstat {
    namespace Private {
        template<class Poly, class Functor>
        void extWeightAverages(const Poly& poly, const Functor& fcn,
                               const AbsIntervalQuadrature1D& quad,
                               unsigned maxdeg, double xmin, double xmax,
                               double* averages);

        template <class Poly, class Functor>
        Matrix<double> extWeightProductAverages(
            const Poly& poly, const Functor& fcn,
            const AbsIntervalQuadrature1D& quad,
            unsigned maxdeg, double xmin, double xmax);
    }
}

#include "npstat/nm/polyPrivateUtils.icc"

#endif // NPSTAT_POLYPRIVATEUTILS_HH_
