#include "npstat/stat/AbsTwoDistros1DFunctor.hh"

namespace npstat {
    AbsTwoDistros1DFunctor::AbsTwoDistros1DFunctor(
        const AbsDistribution1D& nullHypothesis,
        const AbsDistribution1D& alternative)
        : nullPtr_(nullHypothesis.clone()),
          altPtr_(alternative.clone())
    {}

    AbsTwoDistros1DFunctor::AbsTwoDistros1DFunctor(
        const AbsTwoDistros1DFunctor& r)
        : nullPtr_(r.nullPtr_->clone()),
          altPtr_(r.altPtr_->clone())
    {}

    AbsTwoDistros1DFunctor& AbsTwoDistros1DFunctor::operator=(
        const AbsTwoDistros1DFunctor& r)
    {
        if (this != &r)
        {
            nullPtr_ = CPP11_auto_ptr<AbsDistribution1D>(r.nullPtr_->clone());
            altPtr_ = CPP11_auto_ptr<AbsDistribution1D>(r.altPtr_->clone());
        }
        return *this;
    }
}
