#ifndef NPSTAT_ABSTWODISTROS1DFUNCTOR_HH_
#define NPSTAT_ABSTWODISTROS1DFUNCTOR_HH_

/*!
// \file AbsTwoDistros1DFunctor.hh
//
// \brief A base class for functors used to study GoF tests
//
// Author: I. Volobouev
//
// October 2022
*/

#include "geners/CPP11_auto_ptr.hh"

#include "npstat/nm/SimpleFunctors.hh"
#include "npstat/stat/AbsDistribution1D.hh"

namespace npstat {
    class AbsTwoDistros1DFunctor : public Functor1<double, double>
    {
    public:
        AbsTwoDistros1DFunctor(const AbsDistribution1D& nullHypothesis,
                               const AbsDistribution1D& alternative);

        AbsTwoDistros1DFunctor(const AbsTwoDistros1DFunctor&);
        AbsTwoDistros1DFunctor& operator=(const AbsTwoDistros1DFunctor&);

        inline virtual ~AbsTwoDistros1DFunctor() {}

        // The following Functor1<double, double> method still needs
        // to be overriden:
        //
        // virtual double operator()(const double& x) const

    protected:
        CPP11_auto_ptr<AbsDistribution1D> nullPtr_;
        CPP11_auto_ptr<AbsDistribution1D> altPtr_;
    };
}

#endif // NPSTAT_ABSTWODISTROS1DFUNCTOR_HH_
