#ifndef NPSTAT_MAKE_UNBINNEDGOFTEST1D_HH_
#define NPSTAT_MAKE_UNBINNEDGOFTEST1D_HH_

/*!
// \file make_UnbinnedGOFTest1D.hh
//
// \brief A factory function for creating 1-d GOF test objects
//
// Author: I. Volobouev
//
// October 2022
*/

#include "geners/CPP11_auto_ptr.hh"

#include "npstat/stat/AbsUnbinnedGOFTest1D.hh"

namespace npstat {
    CPP11_auto_ptr<AbsUnbinnedGOFTest1D> make_UnbinnedGOFTest1D(
        const std::string& classname, const AbsDistribution1D& nullD,
        unsigned maxDegree, const std::vector<unsigned char>& degreeMask);

#ifdef SWIG
    inline AbsUnbinnedGOFTest1D* make_UnbinnedGOFTest1D_2(
        const std::string& classname, const AbsDistribution1D& nullD,
        const unsigned maxDegree, const std::vector<int>& degreeMask)
    {
        const unsigned sz = degreeMask.size();
        std::vector<unsigned char> m(sz);
        for (unsigned i=0; i<sz; ++i)
        {
            if (degreeMask[i])
                m[i] = 1;
            else
                m[i] = 0;
        }
        CPP11_auto_ptr<AbsUnbinnedGOFTest1D> ptr = 
            make_UnbinnedGOFTest1D(classname, nullD, maxDegree, m);
        return ptr.release();
    }
#endif
}

#endif // NPSTAT_MAKE_UNBINNEDGOFTEST1D_HH_
