#ifndef NPSTAT_PARABOLICEXTREMUM_HH_
#define NPSTAT_PARABOLICEXTREMUM_HH_

#include <cassert>

#include "Python.h"

#include "npstat/nm/MathUtils.hh"

namespace npstat {
    PyObject* parabolicExtremum2(const double x0, const double y0,
                                 const double x1, const double y1,
                                 const double x2, const double y2)
    {
        double extremumCoordinate, extremumValue;
        const bool status = parabolicExtremum(
            x0, y0, x1, y1, x2, y2,
            &extremumCoordinate, &extremumValue);
        PyObject* tup = PyTuple_New(3);
        if (tup)
        {
            PyTuple_SET_ITEM(tup, 0, (status ? Py_True : Py_False));
            PyObject* p = PyFloat_FromDouble(extremumCoordinate);
            assert(p);
            PyTuple_SET_ITEM(tup, 1, p);
            p = PyFloat_FromDouble(extremumValue);
            assert(p);
            PyTuple_SET_ITEM(tup, 2, p);
        }
        return tup;
    }
}

#endif // NPSTAT_PARABOLICEXTREMUM_HH_
