#ifndef NPSTAT_SORTVECTOR_HH_
#define NPSTAT_SORTVECTOR_HH_

#include <vector>
#include <algorithm>
#include <functional>

namespace npstat {
    template<typename T>
    void sortVector(std::vector<T>& v, const bool decreasing=false)
    {
        if (decreasing)
            std::sort(v.begin(), v.end(), std::greater<T>());
        else
            std::sort(v.begin(), v.end());
    }

    template<typename T>
    std::vector<T> sortedVector(const std::vector<T>& iVec,
                                const bool decreasing=false)
    {
        std::vector<T> v(iVec);
        if (decreasing)
            std::sort(v.begin(), v.end(), std::greater<T>());
        else
            std::sort(v.begin(), v.end());
        return v;
    }
}

#endif // NPSTAT_SORTVECTOR_HH_
